

import java.util.ArrayList;

class GRAPHMATRIX{

    private ArrayList<KNOTEN> knoten;   
    private ArrayList<ArrayList<Integer>> matrix;
    private ArrayList<Integer> warteliste;
    private ArrayList<Integer> fertigeKnoten;
    
    GRAPHMATRIX (){
        knoten = new ArrayList<KNOTEN>();
        matrix = new ArrayList<ArrayList<Integer>>();
        warteliste = new ArrayList<Integer>();
        fertigeKnoten = new ArrayList<Integer>();
    }
      
    void ZurückSetzen(){
        knoten.clear();
        matrix.clear();
    }

    /*KnotenGeben 
    Methode, die einen Text erwartet, um einen Knoten zurückzugeben
        Schau dir das gesamte Array an
            Wenn der Bezeichner des Knotens gleich dem Text ist
                Gebe diesen Knoten zurück
            Sonst
                Gib einen leeren Knoten zurück
        Ende Schauen
    Ende Methode*/
    
    /*KnotenNummerGeben 
    Methode, die einen Text erwartet, um eine Position zurückzugeben
        Mache beginnend beim ersten bis zum letzten Knoten folgendes:
            Wenn Bezeichner von Knoten an bestimmter Pos. gleich Text
                Gebe Index dieses Knotens zurück
            Sonst
                Gib -1 zurück
        Ende Machen
    Ende Methode*/
   
    /*KnotenBezeichnerGeben 
    Methode, die Bezeichner des Knotens an bestimmter Stelle zurückgibt
        Wenn die Stelle Sinn macht (innerhalb möglicher Werte)
            Gib Bezeichner des Knotens an der angegebenen Stelle zurück
        Sonst
            Gib leeren Text zurück
        Ende Wenn
    Ende Methode*/

    /*KanteEinfügen
    Methode die Kanten von A nach B mit Gewichtung einfügt
        Lass dir zu beiden Knoten dir Nr geben
        Wenn es beide Knoten gibt und diese nicht identisch sind
            Trage bei Matrix(v,n) die Gewichtung ein
            Trage bei Matrix(n,v) die Gewichtung ein
        Ende Wenn
    Ende Methode*/
    
    /*KantenGewichtGeben
    Methode die zu Strings A+B Gewicht einer eventuellen Kante liefert 
        Lass dir zu beiden Knoten dir Nr geben
        Wenn es beide Knoten gibt
            Gib Matrix(v,n) zurück
        Sonst
            Gib -1 zurück
        Ende Wenn
    Ende Methode*/
       
    /*KnotenEinfügen
    Methode die neuen Knoten mit anzugebendem Bezeichner einfügt
        Merke dir die alte Matrixgröße
        Füge in die Knotenliste einen neu zu erstellenden Knoten ein
        Mache für alle Zeilen der Matrix
            Lass dir eine bestimmte Zeile geben und füge dort -1 ein
        Ende Für alle 
        Füge der Matrix (aus ArrayListen) eine weitere ArrayList dazu
        Mache für diese letzte ArrayList in der Matrix
            Füge -1er ein (einen mehr als alte Matrixgröße)
        Ende Mache
    Ende Methode*/
    
    void Ausgeben(){
        System.out.print("   ");  
        for (int i = 0; i < knoten.size(); i++){
            System.out.print((knoten.get(i).BezeichnerGeben() + "       ").substring(0, 3));
        }
        System.out.println();
        
        for (int i = 0; i < knoten.size(); i++){
            System.out.print((knoten.get(i).BezeichnerGeben() + "        ").substring(0, 3));
            for (int j = 0; j < knoten.size(); j++){
                if (matrix.get(i).get(j) != -1){
                    System.out.print((matrix.get(i).get(j)+ "       ").substring(0, 3));
                }
                else{
                    System.out.print("   ");
                }
            }
            System.out.println();           
        }
    }    
       
    /*BreitensucheAusführen
    Mache Breitensuche für Startknotennummer und Zielknotennummer
        Leere warteliste
        Leere fertigeKnoten
        Setze AktuelleKnotennummer (AKNr) auf StartKnotenNummer (SKNr)
        Mache Folgendes:
            Schau für alle möglichen Knotennummern (KNr)
                Wenn es Kante von AKNr zu KNr gibt 
                        und KNr nicht dabei bei fertigeKnoten 
                        und KNr nicht dabei in warteliste
                    Dann KNr in warteliste einfügen
            *Ende schauen
            Füge AKNr bei fertigeKnoten dazu
            Nehme vordersten Knoten aus warteliste als aktuellen Knoten
            Entferne den ersten Knoten aus der warteliste
        *Solange SKNr != ZKNr und warteliste nicht leer 
        //Prüfen ob Ziel erreicht wurde    
        //Ausgabe aller fertigen Knoten + letzter aktueller Knoten
    Ende Breitensuche*/   
}
